#include "usart.h"

/*
 * Functie de initializare a controllerului USART
 */
void USART0_init(unsigned int ubrr) 
{
	UBRR1H = (unsigned char)(ubrr>>8);
	UBRR1L = (unsigned char)ubrr;
	
	// Enable receiver and transmitter 
	UCSR1B = (1 << TXEN1);
	
	UCSR1C = (1<<UCSZ10)|(1<<UCSZ11);
}

/*
 * Functie ce transmite un caracter prin USART
 *
 * @param data - caracterul de transmis
 */
void uput_char(unsigned char data) 
{
    /* asteapta pana bufferul e gol */
    while(!(UCSR1A & (1<<UDRE1)));

    /* pune datele in buffer; transmisia va porni automat in urma scrierii */
    UDR1 = data;
}

/*
 * Functie ce transmite un sir de caractere prin USART
 *
 * @param data - sirul (terminat cu '\0') de transmis
 */
void USART0_print(char *data) 
{
    while(*data != '\0')
		uput_char(*data++);
}
